program Mer_Game;
uses ammarunit,apsfiles,ammargui;
const version='0.0 - Development Build 24-10-06';
      wndx=500;
      wndy=500;

Type
 Node =
  Record
   link1_x:byte;
   link1_y:byte;
   link2_x:byte;
   link2_y:byte;
   link3_x:byte;
   link3_y:byte;
   link4_x:byte;
   link4_y:byte;
   nodelist_size:byte;
  End;

var i:integer;
    playfield:array[1..7,1..7] of Node;
    game_colors:array[1..2] of integer; //1= Line Color
    player1_remaining,player2_remaining:integer;




procedure load_art;
const MAX_ART=1;
var il,ily,lps:integer;
    aps2load:string;
begin 
lps:=0;
ily:=0;
il:=GetLoadingX;
SetTransparentColor(ConvertRGB(123,123,0));
repeat
lps:=lps+1;
if lps=1 then aps2load:='pioni1';



loadaps(aps2load); 
il:=il+GetApsInfo(aps2load,'sizex')+2;
if ily<GetApsInfo(aps2load,'sizey') then ily:=GetApsInfo(aps2load,'sizey');
if il+GetApsInfo(aps2load,'sizex')+2>2048 then begin
                                                il:=1;
                                                SetLoadingXY(il,GetLoadingY+ily+2);
                                               end;  
SetLoadingXY(il,GetLoadingY);
until lps=MAX_ART;

DuplicateAps('pioni1','pioni2',GetLoadingX,GetLoadingY);  //aps2load DIPLASIASMOS
ChangeApsColor('pioni2',ConvertRGB(255,0,0),ConvertRGB(255,128,64));
SetLoadingXY(GetApsInfo(aps2load,'sizex'),GetLoadingY);

il:=1;
SetLoadingXY(il,GetLoadingY+ily+2); 
end;





procedure setup_nodes(mode:integer);
var x,y:byte;
begin
 for x:=1 to 7 do
   for y:=1 to 7 do
     begin
        playfield[x,y].nodelist_size:=0;
     end;

 playfield[1,1].link1_x:=4;
 playfield[1,1].link1_y:=1;
 playfield[1,1].link2_x:=1;
 playfield[1,1].link2_y:=4; 
 playfield[1,1].nodelist_size:=2;

 playfield[4,1].link1_x:=7;
 playfield[4,1].link1_y:=1; 
 playfield[4,1].link2_x:=1;
 playfield[4,1].link2_y:=1;
 playfield[4,1].link3_x:=4;
 playfield[4,1].link3_y:=2;
 playfield[4,1].nodelist_size:=3;

 playfield[7,1].link1_x:=4;
 playfield[7,1].link1_y:=1;
 playfield[7,1].link2_x:=7;
 playfield[7,1].link2_y:=4;
 playfield[7,1].nodelist_size:=2;

 playfield[2,2].link1_x:=4;
 playfield[2,2].link1_y:=2;
 playfield[2,2].link2_x:=2;
 playfield[2,2].link2_y:=4; 
 playfield[2,2].nodelist_size:=2;

 playfield[4,2].link1_x:=2;
 playfield[4,2].link1_y:=2;
 playfield[4,2].link2_x:=6;
 playfield[4,2].link2_y:=2;
 playfield[4,2].link3_x:=4;
 playfield[4,2].link3_y:=1;
 playfield[4,2].link4_x:=4;
 playfield[4,2].link4_y:=3;
 playfield[4,2].nodelist_size:=4;

 playfield[6,2].link1_x:=4;
 playfield[6,2].link1_y:=2;
 playfield[6,2].link2_x:=6;
 playfield[6,2].link2_y:=4;
 playfield[6,2].nodelist_size:=2;

 playfield[3,3].link1_x:=4;
 playfield[3,3].link1_y:=3;
 playfield[3,3].link2_x:=3;
 playfield[3,3].link2_y:=4;
 playfield[3,3].nodelist_size:=2;

 playfield[4,3].link1_x:=4; playfield[4,3].link1_y:=2;
 playfield[4,3].link2_x:=3; playfield[4,3].link2_y:=3;
 playfield[4,3].link3_x:=5; playfield[4,3].link3_y:=3;
 playfield[4,3].nodelist_size:=3;

 playfield[1,4].link1_x:=1; playfield[1,4].link1_y:=1;
 playfield[1,4].link2_x:=2; playfield[1,4].link2_y:=4;
 playfield[1,4].link3_x:=1; playfield[1,4].link3_y:=7;
 playfield[1,4].nodelist_size:=3;


 playfield[2,4].link1_x:=2; playfield[2,4].link1_y:=2;
 playfield[2,4].link2_x:=1; playfield[2,4].link2_y:=4;
 playfield[2,4].link3_x:=3; playfield[2,4].link3_y:=4;
 playfield[2,4].link4_x:=2; playfield[2,4].link4_y:=6;
 playfield[2,4].nodelist_size:=4;

 playfield[3,4].link1_x:=3; playfield[3,4].link1_y:=3;
 playfield[3,4].link2_x:=2; playfield[3,4].link2_y:=4;
 playfield[3,4].link3_x:=3; playfield[3,4].link3_y:=5;
 playfield[3,4].nodelist_size:=3;

 playfield[5,4].link1_x:=5; playfield[5,4].link1_y:=3;
 playfield[5,4].link2_x:=6; playfield[5,4].link2_y:=4;
 playfield[5,4].link3_x:=5; playfield[5,4].link3_y:=5;
 playfield[5,4].nodelist_size:=3;


 playfield[6,4].link1_x:=6; playfield[6,4].link1_y:=2;
 playfield[6,4].link2_x:=5; playfield[6,4].link2_y:=4;
 playfield[6,4].link3_x:=6; playfield[6,4].link3_y:=7;
 playfield[6,4].link4_x:=7; playfield[6,4].link4_y:=4;
 playfield[6,4].nodelist_size:=4;


 playfield[7,4].link1_x:=7; playfield[7,4].link1_y:=1;
 playfield[7,4].link2_x:=6; playfield[7,4].link2_y:=4;
 playfield[7,4].link3_x:=7; playfield[7,4].link3_y:=7;
 playfield[7,4].nodelist_size:=3;

 


end;


procedure draw_table;
var block:integer;
begin
block:=wndx div 8;
SetLineSettings(6,6,6);
DrawRectangle(block,block,wndx-block,wndy-block,game_colors[1]);  //OUTER RECTANGLE
DrawRectangle(block*2,block*2,wndx-block*2,wndy-block*2,game_colors[1]);  //MIDDLE RECTANGLE
DrawRectangle(block*3,block*3,wndx-block*3,wndy-block*3,game_colors[1]);  //MIDDLE RECTANGLE

SetLineSettings(4,4,4);
DrawLine(block*4,block,block*4,block*3,game_colors[1]); //PANW GRAMMI
DrawLine(block*4,block*5+3,block*4,block*7,game_colors[1]); //KATW GRAMMI

DrawLine(block,block*4,block*3,block*4,game_colors[1]); //ARISTERI GRAMMI
DrawLine(block*5+3,block*4,block*7,block*4,game_colors[1]); //DEKSIA GRAMMI

SetLineSettings(1,1,1);
end;


procedure draw_hud;
var block,i,y:integer;
begin
block:=wndx div 8;

//PLAYER 1
DrawRectangle2(15,block+10,block-15,wndy-block-10,game_colors[1],game_colors[1]);
y:=wndy-block-40;
for i:=1 to player1_remaining do begin
                                  DrawApsXY('pioni1',15,y);
                                  y:=y-GetApsInfo('pioni1','sizey')-5;
                                 end;
OutTextXY(25,y,Convert2String(player1_remaining));
//PLAYER 2
DrawRectangle2(wndx-block+15,block+10,wndx-15,wndy-block-10,game_colors[1],game_colors[1]);
y:=wndy-block-40;
for i:=1 to player1_remaining do begin
                                  DrawApsXY('pioni2',wndx-block+15,y);
                                  y:=y-GetApsInfo('pioni2','sizey')-5;
                                 end;
OutTextXY(wndx-block+25,y,Convert2String(player1_remaining));
//include_object('layer('+Convert2String(daysdrawn)+')','layer','1','no','','select',x11,y11,x22,y22);
           
end;


procedure play_game;
begin
end;














begin
InitGraph('Merelles GUI '+version,wndx,wndy,0);
load_skin('');
SetFont('arial','greek',15,0,0,0); 

setup_nodes(0);
load_art;
player1_remaining:=9;
player2_remaining:=9;
game_colors[1]:=ConvertRGB(0,64,64);

flush_gui_memory(0);
set_gui_color(ConvertRGB(0,0,0),'comment');
clrscreen;
include_object('backwindow','window','Merelles '+version,'','','',1,1,wndx,wndy);
draw_all;
delete_object('backwindow','NAME');  
draw_table;
include_object('player1','comment','Player 1','','','',20,(wndy div 8)-17,0,0);
include_object('player2','comment','Player 2','','','',wndx-(wndy div 8)+5,(wndy div 8)-17,0,0);
draw_hud;
draw_all;
repeat
interact;
until GUI_Exit;

CloseGraph;
Halt;
end.
